new;
library edf,pgraph;

declare matrix N;
 
S0 = 3.5;
K = 3.495;
sigma = 0.09;
tau = 90/365;
r = 0.08;
rstar = 0.06;


proc deltaGK(S0,K,sigma,tau,r,rstar);
  local w,d1,delta;

  w = sigma.*sqrt(tau);
  d1 = ( ln(S0./K) + (r-rstar).*tau )./w + 0.5*w;

  delta = exp(-rstar.*tau).*cdfn(d1);

  retp(delta);
endp;


proc FonctionAuxiliaire(S0);
  local C,P;

  {C,P} = optionCRR(S0,K,sigma,tau,r,rstar,N);
  retp(C);
endp;

output file = delta3.out reset;

delta1 = deltaGK(S0,K,sigma,tau,r,rstar);
print "delta1 = " delta1;

for N (1,5,1);
  delta2 = gradp(&FonctionAuxiliaire,S0);
  print delta2;
endfor;

print "N = " N;

for i (1,10,1);
  N = i;
  delta2 = gradp(&FonctionAuxiliaire,S0);
  print delta2;
endfor;

output off;