new;
library edf;

S0 = 3.5;
K = 3.49;
sigma = 0.09;
r = 0.08;
rstar = 0.06;
tau = 60/365;

proc muProc(t,S);
  retp( (r-rstar)*S );
endp;

proc sigmaProc(t,S);
  retp( sigma*S );
endp;

N = 60;    /* Nombre de points de discretisation, 1 simulation par jour */
Ns = 1000; /* Nombre de simulations */

{t,S} = EulerMaruyama(S0,&muProc,&sigmaProc,0,tau,N,Ns);

ST = S[N,.]';
G = ST - K;
G = G .* (G .> 0);
Cs = exp(-r*tau)*meanc(G);

C = callGK(S0,K,sigma,tau,r,rstar);

output file = eds2.out reset;

print ftos(C,"Valeur theorique : %lf",6,5);
print ftos(Cs,"Valeur simulee : %lf",6,5);

output off;