new;
library edf,pgraph;

S0 = 3.5;
sigma = 0.09;
r = 0.08;
rstar = 0.06;
tau = 60/365;

proc muProc(t,S);
  retp( (r-rstar)*S );
endp;

proc sigmaProc(t,S);
  retp( sigma*S );
endp;

Ns = 1000; /* Nombre de simulations */


N = 20;    /* 1 simulation tous les 3 jours */

{t,S} = EulerMaruyama(S0,&muProc,&sigmaProc,0,tau,N,Ns);

ST = S[N,.]';
Smin = minc(S);
G = ST - Smin;
G = G .* (G .> 0);
Cs1 = exp(-r*tau)*meanc(G);


N = 120;    /* 2 simulations par jour */

{t,S} = EulerMaruyama(S0,&muProc,&sigmaProc,0,tau,N,Ns);

ST = S[N,.]';
Smin = minc(S);
G = ST - Smin;
G = G .* (G .> 0);
Cs2 = exp(-r*tau)*meanc(G);

output file = eds3.out reset;

print ftos(Cs1,"Valeur simulee (N = 20) : %lf",6,5);
print ftos(Cs2,"Valeur simulee (N = 120) : %lf",6,5);

output off;