new;
library edf,pgraph;

S0 = 3.5;
V0 = 0.09;

K = 3.49;
r = 0.08;
rstar = 0.06;
tau = 60/365;

rho_ = -0.5;
nu = 0.9;
eta = 0.3;


RHO = ( 1 ~ rho_ ) | (rho_ ~ 1 );

proc muProc(t,X);
  local S,V,mu;
  S = X[1];
  V = X[2];
  mu = (r-rstar)*S |
        nu*V       ;
  retp( mu );
endp;

proc sigmaProc(t,X);
  local S,V,sig;
  S = X[1];
  V = X[2];
  sig = ( V*S ~ 0    ) |
        ( 0   ~ eta*V) ;
  retp( sig );
endp;

N = 600; 
{t,X} = EDSm(S0|V0,&muProc,&sigmaProc,RHO,0,tau,N);

graphset;
  _pnum = 2; _pnumht = 0.25; _ptitlht = 0.30; _pdate = "";
  begwind;
  window(2,1,0);
  setwind(1);
    title("Simulation de S");
    xy(t,X[.,1]);
  setwind(2);
    title("Simulation de V");
    xy(t,X[.,2]);
    graphprt("-c=1 -cf=hw1.eps");
  endwind;