new;
library edf,tsm,optmum,pgraph;

S0 = 3.5; K = 3.51; sigma = 0.19; tau = 90/365;
r = 0.08; rstar = 0.075;
Narbitrage = 4;

deltaTau = -4/365;  /* 4 jours */
deltaT = -deltaTau;

proc muProc(t,S);
  retp( (r-rstar)*S );
endp;

proc sigmaProc(t,S);
  retp( sigma*S );
endp;

/* t0 */

{C0,arbreC} = OptionAmericaine(S0,K,sigma,tau,r,rstar,Narbitrage);

/* t1 */

Ns = 1000;
{t,S} = EulerMaruyama(S0,&muProc,&sigmaProc,0,deltaT,10,Ns);

S1 = S[10,.]';
C1 = zeros(Ns,1);
i = 1;
do until i > Ns;
  {C1[i],arbreC} = OptionAmericaine(S1[i],K,sigma,tau+deltaTau,r,rstar,Narbitrage);
  i = i + 1;
endo;

deltaC = C1 - C0;

{absc,dens,repart,retcode} = Kernel(deltaC);

graphset;
  _pdate = ""; _pnum = 2;
  title("Fonction de densite de la variation de la valeur de l'option");
  graphprt("-c=1 -cf=var7.eps"); 
  xy(absc,dens);
