new;
library edf,pgraph;

S0 = 3.5;
K = 3.5;
tau = 60/365;
r = 0.08;
rstar = 0.06;

C = 0.056;

proc FonctionObjectif(sigma);
   retp(callGK(S0,K,sigma,tau,r,rstar) - C );
endp;

output file = volimp1.out reset;

print callGK(S0,K,0.01,tau,r,rstar);
print callGK(S0,K,0.50,tau,r,rstar);

volimp = bisection(&FonctionObjectif,0.01,0.50);

print "Volatilite implicite = " volimp;

output off;


tau = seqa(10/365,1/365,100);
e = ones(rows(tau),1);
volimp = bisection(&FonctionObjectif,0.01*e,0.50*e);

graphset;
  _pnum = 2; _pdate = ""; _paxht = 0.25;
  fonts("simplex simgrma");
  xlabel("\202t\201");
  ylabel("\202s\201[implicite]");
  graphprt("-c=1 -cf=volimp1.eps");
  xy(tau,volimp);
